// Verilated -*- C++ -*-
// DESCRIPTION: Verilator output: Model implementation (design independent parts)

#include "Vsecret_impl__pch.h"

//============================================================
// Constructors

Vsecret_impl::Vsecret_impl(VerilatedContext* _vcontextp__, const char* _vcname__)
    : VerilatedModel{*_vcontextp__}
    , vlSymsp{new Vsecret_impl_PS5LFE(contextp(), _vcname__, this)}
    , clk{vlSymsp->TOP.clk}
    , a{vlSymsp->TOP.a}
    , b{vlSymsp->TOP.b}
    , x{vlSymsp->TOP.x}
    , rootp{&(vlSymsp->TOP)}
{
    // Register model with the context
    contextp()->addModel(this);
}

Vsecret_impl::Vsecret_impl(const char* _vcname__)
    : Vsecret_impl(Verilated::threadContextp(), _vcname__)
{
}

//============================================================
// Destructor

Vsecret_impl::~Vsecret_impl() {
    delete vlSymsp;
}

//============================================================
// Evaluation function

#ifdef VL_DEBUG
void Vsecret_impl_PSMfND__PSBB95(Vsecret_impl_PSMfND* vlSelf);
#endif  // VL_DEBUG
void Vsecret_impl_PSMfND__PSzKfP(Vsecret_impl_PSMfND* vlSelf);
void Vsecret_impl_PSMfND__PSbcJW(Vsecret_impl_PSMfND* vlSelf);
void Vsecret_impl_PSMfND__PSTjus(Vsecret_impl_PSMfND* vlSelf);
void Vsecret_impl_PSMfND__PSLadq(Vsecret_impl_PSMfND* vlSelf);

void Vsecret_impl::eval_step() {
    VL_DEBUG_IF(VL_DBG_MSGF("+++++TOP Evaluate Vsecret_impl::eval_step\n"); );
#ifdef VL_DEBUG
    // Debug assertions
    Vsecret_impl_PSMfND__PSBB95(&(vlSymsp->TOP));
#endif  // VL_DEBUG
    vlSymsp->__Vm_deleter.deleteAll();
    if (VL_UNLIKELY(!vlSymsp->__Vm_didInit)) {
        vlSymsp->__Vm_didInit = true;
        VL_DEBUG_IF(VL_DBG_MSGF("+ Initial\n"););
        Vsecret_impl_PSMfND__PSzKfP(&(vlSymsp->TOP));
        Vsecret_impl_PSMfND__PSbcJW(&(vlSymsp->TOP));
        Vsecret_impl_PSMfND__PSTjus(&(vlSymsp->TOP));
    }
    VL_DEBUG_IF(VL_DBG_MSGF("+ Eval\n"););
    Vsecret_impl_PSMfND__PSLadq(&(vlSymsp->TOP));
    // Evaluate cleanup
    Verilated::endOfEval(vlSymsp->__Vm_evalMsgQp);
}

//============================================================
// Events and timing
bool Vsecret_impl::eventsPending() { return false; }

uint64_t Vsecret_impl::nextTimeSlot() {
    VL_FATAL_MT(__FILE__, __LINE__, "", "No delays in the design");
    return 0;
}

//============================================================
// Utilities

const char* Vsecret_impl::name() const {
    return vlSymsp->name();
}

//============================================================
// Invoke final blocks

void Vsecret_impl_PSMfND__PS6cYS(Vsecret_impl_PSMfND* vlSelf);

VL_ATTR_COLD void Vsecret_impl::final() {
    Vsecret_impl_PSMfND__PS6cYS(&(vlSymsp->TOP));
}

//============================================================
// Implementations of abstract methods from VerilatedModel

const char* Vsecret_impl::hierName() const { return vlSymsp->name(); }
const char* Vsecret_impl::modelName() const { return "Vsecret_impl"; }
unsigned Vsecret_impl::threads() const { return 1; }
void Vsecret_impl::prepareClone() const { contextp()->prepareClone(); }
void Vsecret_impl::atClone() const {
    contextp()->threadPoolpOnClone();
}
